summaryrefslogtreecommitdiffstats
path: root/source/xap/x3270
diff options
context:
space:
mode:
Diffstat (limited to 'source/xap/x3270')
-rwxr-xr-xsource/xap/x3270/x3270.SlackBuild70
1 files changed, 55 insertions, 15 deletions
diff --git a/source/xap/x3270/x3270.SlackBuild b/source/xap/x3270/x3270.SlackBuild
index 225142a24..fd2f53fa7 100755
--- a/source/xap/x3270/x3270.SlackBuild
+++ b/source/xap/x3270/x3270.SlackBuild
@@ -1,6 +1,6 @@
#!/bin/sh
-# Copyright 2008, 2009 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2008, 2009, 2012 Patrick J. Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -20,10 +20,48 @@
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-TARBVER=3.3.7p8
-VERSION=3.3.7p8
-ARCH=${ARCH:-x86_64}
-BUILD=${BUILD:-1}
+PKGNAM=x3270
+VERSION=3.3
+TARBVER=${TARBVER:-$(echo $PKGNAM-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+VERSION=$(echo $TARBVER | cut -f 1,2 -d .)
+BUILD=${BUILD:-2}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i486 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7lh ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
NUMJOBS=${NUMJOBS:-" -j7 "}
@@ -35,7 +73,7 @@ rm -rf $PKG
mkdir -p $TMP $PKG
cd $TMP
rm -rf x3270-$VERSION
-tar xvf $CWD/x3270-$TARBVER.tar.bz2 || exit 1
+tar xvf $CWD/x3270-$TARBVER.tar.?z* || exit 1
cd x3270-3.3 || exit 1
chown -R root:root .
find . \
@@ -44,6 +82,8 @@ find . \
\( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
-exec chmod 644 {} \;
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
./configure \
--prefix=/usr \
--sysconfdir=/etc/X11 \
@@ -54,13 +94,13 @@ make install DESTDIR=$PKG
mv $PKG/etc/X11/x3270/ibm_hosts $PKG/etc/X11/x3270/ibm_hosts.new
find $PKG -name fonts.dir -exec rm {} \;
-if [ -d $PKG/usr/lib/X11/fonts/misc ]; then
+if [ -d $PKG/usr/lib$LIBDIRSUFFIX/X11/fonts/misc ]; then
mkdir -p $PKG/usr/share/fonts
- mv $PKG/usr/lib/X11/fonts/misc $PKG/usr/share/fonts
- rmdir $PKG/usr/lib/X11/fonts/misc 2> /dev/null
- rmdir $PKG/usr/lib/X11/fonts 2> /dev/null
- rmdir $PKG/usr/lib/X11 2> /dev/null
- rmdir $PKG/usr/lib 2> /dev/null
+ mv $PKG/usr/lib$LIBDIRSUFFIX/X11/fonts/misc $PKG/usr/share/fonts
+ rmdir $PKG/usr/lib$LIBDIRSUFFIX/X11/fonts/misc 2> /dev/null
+ rmdir $PKG/usr/lib$LIBDIRSUFFIX/X11/fonts 2> /dev/null
+ rmdir $PKG/usr/lib$LIBDIRSUFFIX/X11 2> /dev/null
+ rmdir $PKG/usr/lib$LIBDIRSUFFIX 2> /dev/null
fi
mkdir -p $PKG/etc/X11/app-defaults
@@ -75,15 +115,15 @@ for file in x3270-script.man x3270.man x3270if.man ; do
done
cat ibm_hosts.man | gzip -9c > $PKG/usr/man/man5/ibm_hosts.5.gz
-mkdir -p $PKG/usr/doc/x3270-$VERSION
+mkdir -p $PKG/usr/doc/x3270-$TARBVER
cp -a \
LICENSE README* Examples html \
- $PKG/usr/doc/x3270-$VERSION
+ $PKG/usr/doc/x3270-$TARBVER
mkdir -p $PKG/install
zcat $CWD/doinst.sh.gz > $PKG/install/doinst.sh
cat $CWD/slack-desc > $PKG/install/slack-desc
cd $PKG
-/sbin/makepkg -l y -c n $TMP/x3270-$VERSION-$ARCH-$BUILD.txz
+/sbin/makepkg -l y -c n $TMP/x3270-$TARBVER-$ARCH-$BUILD.txz